//(C) 2001 S2 Games

#include "core.h"
#include "navrep.h"

void Host_GetCoreAPI(coreAPI_shared_t *api_shared, coreAPI_client_t *api_c, coreAPI_server_t *api_s, coreAPI_interface_t *api_i)
{
	if (api_c)
	{
//		api_c->Path_Create = Path_Create2;
//		api_c->Path_DrawPaths = Path_DrawPaths;
		api_c->System_Dir = System_Dir;
		api_c->Cmd_Register = Cmd_Register;
		api_c->Cmd_BufPrintf = Cmd_BufPrintf;
		//api_c->Cmd_ExecBuf = Cmd_ExecBuf;
		api_c->Cmd_Exec = Cmd_Exec;
		api_c->Cmd_FlushScriptBuffer = Cmd_FlushScriptBuffer;
		api_c->Cmd_ReadConfigFileVars = Cmd_ReadConfigFileVars;
		api_c->Cmd_Enable = Cmd_Enable;
		api_c->Cmd_Disable = Cmd_Disable;
		api_c->Cmd_ProcessString = Cmd_ProcessString;
		api_c->Cvar_Register = Cvar_Register;
		api_c->Cvar_Set = Cvar_Set;
		api_c->Cvar_SetVar = Cvar_SetVar;
		api_c->Cvar_SetValue = Cvar_SetValue;
		api_c->Cvar_GetValue = Cvar_GetValue;
		api_c->Cvar_GetInteger = Cvar_GetInteger;
		api_c->Cvar_GetString = Cvar_GetString;
		api_c->Cvar_SetVarValue = Cvar_SetVarValue;
		api_c->Cvar_GetModifiedCount = Cvar_GetModifiedCount;
		api_c->Console_Printf = Console_Printf;
		api_c->Console_DPrintf = Console_DPrintf;
		api_c->Console_Errorf = Console_Errorf;
		api_c->World_SampleGround = World_SampleGround;
		api_c->World_GetBounds = World_GetBounds;
		api_c->World_GetGridHeight = World_GetGridHeight;
		api_c->World_Destroy = World_Destroy;
		api_c->World_DeformGround = World_DeformGround;
//		api_c->World_PlaceSolid = WT_PlaceSolid;
//		api_c->World_RemoveSolid = WT_RemoveSolid;
//		api_c->World_TestBox = WT_TestBox;
//		api_c->World_TraceLineSegment = WT_TraceLineSegment;
//		api_c->World_TestSolid = WT_TestSolid;
		api_c->World_TraceBox = WT_TraceBox_Client;			//client-side version
		api_c->World_TraceBoxEx = WT_TraceBoxEx_Client;		//client-side version
		api_c->World_LinkObject = WT_LinkObject_Client;		//client-side version
		api_c->World_UnlinkObject = WT_UnlinkObject_Client; //client-side version
		api_c->World_FitPolyToTerrain = WT_FitPolyToTerrain;		
		api_c->World_GetName = World_GetName;
		api_c->World_UseColormap = World_UseColormap;
		api_c->World_CalcMaxZ = World_CalcMaxZUnaligned;
		api_c->WorldToGrid = World_WorldToGrid;
		api_c->GridToWorld = World_GridToWorld;
		api_c->World_GetOccluder = World_GetOccluder;
		api_c->World_UpdateOccluder = World_UpdateOccluder;
		api_c->World_GetNumOccluders = World_GetNumOccluders;
		api_c->World_AddOccluder = World_AddOccluder;
		api_c->World_ClearOccluders = World_ClearOccluders;
		api_c->World_RemoveOccluder = World_RemoveOccluder;
		api_c->WR_GetSunVector = WR_GetSunVector;
		api_c->WR_ClearDynamap = WR_ClearDynamap;
		api_c->WR_ClearDynamapToColor = WR_ClearDynamapToColor;
		api_c->WR_ClearDynamapToColorEx = WR_ClearDynamapToColorEx;
		api_c->WR_GetDynamap = WR_GetDynamap;
		api_c->WR_SetDynamap = WR_SetDynamap;
		api_c->WR_SetColormap = WR_SetColormap;
		api_c->WR_GetColormap = WR_GetColormap;
		api_c->WR_PaintShader = WR_PaintShader;
		api_c->WR_FarClip = WR_FarClip;
//		api_c->WR_FitQuad = WR_FitQuad;
		api_c->WO_GetNumObjdefs = WO_GetNumObjdefs;
		api_c->WO_GetObjdefName = WO_GetObjdefName;
		api_c->WO_RegisterObjectVar = WO_RegisterObjectVar;
		api_c->WO_GetObjdefVar = WO_GetObjdefVar;
		api_c->WO_GetObjdefVarValue = WO_GetObjdefVarValue;
		api_c->WO_UseObjdef = WO_UseObjdef;
		api_c->WO_GetObjectPos = WO_GetObjectPos;
		api_c->WO_GetObjectSound = WO_GetObjectSound;
		api_c->WO_CreateObjectClass = WO_CreateObjectClass;
		api_c->WO_CreateObject = WO_CreateObject_Client;
		api_c->WO_ClearObjects = WO_ClearObjects;
		api_c->WO_GetObjectBounds = WO_GetObjectBounds;
		api_c->WO_DeleteObject = WO_DeleteObject_Client;
		api_c->WO_GetObjectObjdef = WO_GetObjectObjdef;
		api_c->WO_GetObjectModel = WO_GetObjectModel;
		api_c->WO_GetObjectSkin = WO_GetObjectSkin;
		api_c->WO_GetObjdefId = WO_GetObjdefId;
		api_c->WO_IsObjectDoubleSided = WO_IsObjectDoubleSided;
		api_c->WO_IsObjectReference = WO_IsObjectReference;
		api_c->WO_SetObjectModelAndSkin = WO_SetObjectModelAndSkin;
		api_c->WO_RenderObjects = WO_RenderObjects;
		api_c->Input_Event = Input_Event;
		api_c->Input_SetMouseMode = Input_SetMouseMode;
		api_c->Input_GetMouseMode = Input_GetMouseMode;
		api_c->Input_IsKeyDown = Input_IsKeyDown;
		api_c->Input_CenterMouse = Input_CenterMouse;
		api_c->Input_SetMouseAngles = Input_SetMouseAngles;
		api_c->Input_SetMouseXY = Input_SetMouseXY;
		api_c->Input_GetMousePos = Input_GetMousePos;
		api_c->Input_ActivateInputCallback = Input_ActivateInputCallback;
		api_c->Input_DeactivateInputCallback = Input_DeactivateInputCallback;
		api_c->Input_GetCallbackWidget = Input_GetCallbackWidget;
		api_c->Input_GetKeyFromName = Input_GetKeyFromName;
		api_c->Input_GetNameFromKey = Input_GetNameFromKey;
		api_c->Input_GetBindDownCmd = Input_GetBindDownCmd;
		api_c->Input_GetBindUpCmd = Input_GetBindUpCmd;
		api_c->Input_GetButtons = Input_GetButtons;
		api_c->Input_SetSensitivityScale = Input_SetSensitivityScale;
		api_c->Scene_AddObject = Scene_AddObject;
		api_c->Scene_AddLight = Scene_AddLight;
		api_c->Scene_AddOccluder = Scene_AddOccluder;
		api_c->Scene_Clear = Scene_Clear;
		api_c->Scene_Render = Scene_Render;
		api_c->Scene_AddPoly = Scene_AddPoly;
		api_c->Scene_AddSkyObj = Scene_AddSkyObj;
		api_c->Scene_SelectObjects = Scene_SelectObjects;
		api_c->Scene_SetFrustum = Scene_SetFrustum;
		api_c->Scene_ObjectInFrustum = Scene_ObjectInFrustum;
		api_c->Draw_SetShaderTime = Draw_SetShaderTime;
		api_c->Draw_SetColor = Draw_SetColor;
		api_c->Draw_Quad2d = Draw_Quad2d;
		api_c->Draw_Poly2d = Draw_Poly2d;
	//	api_c->Draw_RotatedQuad2d = Draw_RotatedQuad2d;
		api_c->Color_Clamp = Color_Clamp;
		api_c->Color_ToFloat = Color_ToFloat;
		api_c->Color_ToByte = Color_ToByte;
		api_c->Vid_GetScreenW = Vid_GetScreenW;
		api_c->Vid_GetScreenH = Vid_GetScreenH;
		api_c->Vid_ProjectVertex = Vid_ProjectVertex;
		api_c->Vid_ReadZBuffer = Vid_ReadZBuffer;
		api_c->Cam_ConstructRay = Cam_ConstructRay;
		api_c->System_Milliseconds = System_Milliseconds;
		api_c->Milliseconds = Host_Milliseconds;
		api_c->FrameSeconds = Host_FrameSeconds;
		api_c->FrameMilliseconds = Host_FrameMilliseconds;
		api_c->GetLogicFPS = Host_GetLogicFPS;
		api_c->GetSavageLogoShader = Host_GetSavageLogoShader;
		api_c->GetWhiteShader = Host_GetWhiteShader;	
		api_c->GetSysfontShader = Host_GetSysfontShader;
		api_c->GetNicefontShader = Host_GetNicefontShader;
		api_c->Res_LoadModel = Res_LoadModel;
		api_c->Res_GetModelSurfaceBounds = Res_GetModelSurfaceBounds;
		api_c->Res_LoadSound = Res_LoadSound;
		api_c->Res_LoadSkin = Res_LoadSkin;
		api_c->Res_LoadShader = Res_LoadShader;
		api_c->Res_LoadShaderEx = Res_LoadShaderEx;
		api_c->Res_LoadTerrainShader = Res_LoadTerrainShader;
		api_c->Res_GetModelVisualBounds = Res_GetModelVisualBounds;
		api_c->Res_IsShaderFile = Res_IsShaderFile;
		api_c->Res_GetNumTextureFrames = Res_GetNumTextureFrames;
		api_c->Res_GetAnimatedTextureFPS = Res_GetAnimatedTextureFPS;
		api_c->Res_GetDynamapShader = Res_GetDynamapShader;
		api_c->Res_GetMoviePlayCount = Res_GetMoviePlayCount;
#ifdef THEORA
		api_c->Res_BinkStop = Res_TheoraStop;
		api_c->Res_BinkContinue = Res_TheoraContinue;
		api_c->Res_BinkRestart = Res_TheoraRestart;
		api_c->Res_BinkUnload = Res_TheoraUnload;
#else
		api_c->Res_BinkStop = Res_BinkStop;
		api_c->Res_BinkContinue = Res_BinkContinue;
		api_c->Res_BinkRestart = Res_BinkRestart;
		api_c->Res_BinkUnload = Res_BinkUnload;
#endif
		api_c->Bitmap_Load = Bitmap_Load;
		api_c->Bitmap_GetColor = Bitmap_GetColor;
		api_c->Bitmap_Free = Bitmap_Free;
		api_c->Bitmap_Scale = Bitmap_Scale;
		api_c->Bitmap_GenerateThumbnails = Bitmap_GenerateThumbnails;
		api_c->Bitmap_SetPixel4b = Bitmap_SetPixel4b;
		api_c->Sound_Play = Sound_Play;
		api_c->Sound_ClearLoopingSounds = Sound_ClearLoopingSounds;
		api_c->Sound_AddLoopingSound = Sound_AddLoopingSound;
		api_c->Sound_StopSource = Sound_StopSource;
		api_c->Sound_StopHandle = Sound_StopHandle;
		api_c->Sound_StopChannel = Sound_StopChannel;
		api_c->Sound_MoveSource = Sound_MoveSource;
		api_c->Sound_SetListenerPosition = Sound_SetListenerPosition;
		api_c->Sound_PlayMusic = Sound_PlayMusic;
		api_c->Sound_StopMusic = Sound_StopMusic;
		api_c->GUI_GetUserdata = GUI_GetUserdata;
		api_c->GUI_SetUserdata = GUI_SetUserdata;
		api_c->GUI_RegisterClass = GUI_RegisterClass;
		api_c->GUI_SetName = GUI_SetName;
		api_c->GUI_SetClass = GUI_SetClass;
		api_c->GUI_Notify = GUI_Notify;
		api_c->GUI_IsVisible = GUI_IsVisible;
		api_c->GUI_IsInteractive = GUI_IsInteractive;
		api_c->GUI_Exec = GUI_Exec;
		api_c->GUI_Move = GUI_Move;
		api_c->GUI_Resize = GUI_Resize;
		api_c->GUI_Show = GUI_Show;
		api_c->GUI_Hide = GUI_Hide;
		api_c->GUI_Unfocus = GUI_Unfocus;
		api_c->GUI_Focus = GUI_Focus;
		api_c->GUI_Select = GUI_Select;
		api_c->GUI_Param = GUI_Param;
		api_c->GUI_UpdateDims = GUI_UpdateDims;
		api_c->GUI_GetPosition = GUI_GetPosition;
		api_c->GUI_GetSize = GUI_GetSize;
		api_c->GUI_FadeOut = GUI_FadeOutObject;
		api_c->GUI_FadeIn = GUI_FadeOutObject;
		api_c->GUI_GetWidgetAtXY = GUI_GetWidgetAtXY;
		api_c->GUI_CheckMouseAgainstUI = GUI_CheckMouseAgainstUI;
		api_c->GUI_SendMouseDown = GUI_SendMouseDown;
		api_c->GUI_SendMouseUp = GUI_SendMouseUp;
		api_c->GUI_WidgetWantsMouseClicks = GUI_WidgetWantsMouseClicks;
		api_c->GUI_WidgetWantsKey = GUI_WidgetWantsKey;
		api_c->GUI_ResetFocus = GUI_ResetFocus;
		api_c->GUI_ActivateNextInteractiveWidget = GUI_ActivateNextInteractiveWidget;
		api_c->GUI_RotatedQuad2d_S = GUI_RotatedQuad2d_S;
		api_c->GUI_Quad2d_S = GUI_Quad2d_S;
		api_c->GUI_ShadowQuad2d_S = GUI_ShadowQuad2d_S;
		api_c->GUI_GetStringRowsCols = GUI_GetStringRowsCols;
		api_c->GUI_DrawString = GUI_DrawString;
		api_c->GUI_DrawShadowedString = GUI_DrawShadowedString;
		api_c->GUI_DrawString_S = GUI_DrawString_S;
		api_c->GUI_DrawStringBillboard = GUI_DrawStringBillboard;
		api_c->GUI_DrawStringMonospaced = GUI_DrawStringMonospaced;
		api_c->GUI_StringWidth = GUI_StringWidth_S;
		api_c->GUI_LineBox2d_S = GUI_LineBox2d_S;
		api_c->GUI_SetRGB = GUI_SetRGB;
		api_c->GUI_SetRGBA = GUI_SetRGBA;
		api_c->GUI_Panel_AddObject = GUI_Panel_AddObject;
		api_c->GUI_Panel_Move = GUI_Panel_Move;
		api_c->GUI_Panel_MoveRelative = GUI_Panel_MoveRelative;
		api_c->GUI_Panel_Hide = GUI_Panel_Hide;
		api_c->GUI_Panel_Show = GUI_Panel_Show;
		api_c->GUI_GetPanel = GUI_GetPanel;
		api_c->GUI_AddElement = GUI_AddElement;
		api_c->GUI_GetScreenPosition = GUI_GetScreenPosition;
		api_c->GUI_GetScreenSize = GUI_GetScreenSize;
		api_c->GUI_GetObject = GUI_GetObject;
		api_c->GUI_GetClass = GUI_GetClass;
		api_c->GUI_List_Cmd = GUI_List_Cmd;
		api_c->GUI_Draw = GUI_Draw;
		api_c->GUI_Init = GUI_Init;
		api_c->GUI_Malloc = GUI_Malloc;
		api_c->GUI_Free = GUI_Free;
		api_c->GUI_ReAlloc = GUI_ReAlloc;
		api_c->GUI_StrDup = GUI_StrDup;
		api_c->GUI_Coord = GUI_Coord;
		api_c->GUI_ConvertToScreenCoord = GUI_ConvertToScreenCoord;
		api_c->GUI_ScaleToScreen = GUI_ScaleToScreen;
		api_c->GUI_Scale = GUI_Scale;
		api_c->GUI_GetScreenWidth = GUI_GetScreenWidth;
		api_c->GUI_GetScreenHeight = GUI_GetScreenHeight;
		api_c->GUI_HideAllPanels = GUI_HideAllPanels;
		api_c->GUI_DestroyAll = GUI_RemovePanels;
/*		api_c->Particles_Reset = Particles_Reset;
		api_c->Particles_GetConfigCount = Particles_GetConfigCount;
		api_c->Particles_GetSystemCount = Particles_GetSystemCount;
		api_c->Particles_GetBehaviorCount = Particles_GetBehaviorCount;
		api_c->Particles_Contains = Particles_Contains;
		api_c->Particles_DisplayActive = Particles_DisplayActive;
		api_c->Particles_Allocate = Particles_Allocate;
		api_c->Particles_Free = Particles_Free;
		api_c->Particles_Behavior_Init = Particles_Behavior_Init;
		api_c->Particles_UpdateConfig = Particles_UpdateConfig;
		api_c->Particles_MakeConfig = Particles_MakeConfig;
*/
		api_c->SetTimeOfDay = TOD_SetTime;
		api_c->TOD_GetNumKeyframes = TOD_GetNumKeyframes;
		api_c->TOD_GetKeyframeTime = TOD_GetKeyframeTime;
		api_c->TOD_MoveKeyframe = TOD_MoveKeyframe;
				
		api_c->Client_SendMessageToServer = Client_SendMessageToServer;
		api_c->Client_RequestStateString = Client_RequestStateString;
		api_c->Client_GameObjectPointer = Client_GameObjectPointer;
		api_c->Client_GetInputState = Client_GetInputState;
		api_c->Client_GetCurrentInputStateNum = Client_GetCurrentInputStateNum;
		api_c->Client_GetRealPlayerState = Client_GetRealPlayerState;
		api_c->Client_GetOwnClientNum = Client_GetOwnClientNum;
		api_c->Client_ModifyInputStateItem = Client_ModifyInputStateItem;
		api_c->Client_ModifyInputStateAngles = Client_ModifyInputStateAngles;
		api_c->Client_GetStateString = Client_GetStateString;
		api_c->Client_GetConnectionState = Client_GetConnectionState;
		api_c->Client_ConnectionProblems = Client_ConnectionProblems;
		api_c->Client_IsPlayingDemo = Client_IsPlayingDemo;

		api_c->MasterServer_GetGameList = MasterServer_GetGameList;
		api_c->MasterServer_GetGameList_Frame = MasterServer_GetGameList_Frame;
		api_c->MasterServer_GetGameInfo = MasterServer_GetGameInfo;
		api_c->MasterServer_FindUsers = MasterServer_FindUsers;
		api_c->MasterServer_GetUserList_Frame = MasterServer_GetUserList_Frame;
		api_c->MasterServer_GetUserInfo = MasterServer_GetUserInfo;
		api_c->MasterServer_GetUserInfo_Frame = MasterServer_GetUserInfo_Frame;

		api_c->Geom_BeginPose = Geom_BeginPose;
		api_c->Geom_RotateBone = Geom_RotateBone;
		api_c->Geom_SetBoneAnim = Geom_SetBoneAnim;
		api_c->Geom_SetBoneAnimNoPose = Geom_SetBoneAnimNoPose;
		api_c->Geom_EndPose = Geom_EndPose;
		api_c->Geom_GetBoneIndex = Geom_GetBoneIndex;
		api_c->Geom_SetBoneState = Geom_SetBoneState;
		api_c->Geom_FreeSkeleton = Geom_FreeSkeleton;
//		api_c->Geom_MapSkeleton = Geom_MapSkeleton;

		api_c->HTTP_GetText = HTTP_GetText;
		api_c->HTTP_GetFile = HTTP_GetFile;
		api_c->HTTP_OpenFile = HTTP_OpenFile;
		
		api_c->File_CacheClanIcon = File_CacheClanIcon;
		api_c->File_FlushClanIcon = File_FlushClanIcon;
		/*api_c->Mem_ResetCopyCount = Mem_ResetCopyCount;
		api_c->Mem_GetBytesCopied = Mem_GetBytesCopied;*/

		api_c->Tag_Malloc = Tag_MallocClientGame;
		api_c->Tag_Free = Tag_Free;

		api_c->Speak = System_Say;

		api_c->TranslateString = Host_TranslateString;
	}

	if (api_i)
	{
		api_i->System_Dir = System_Dir;
		api_i->Cmd_Register = Cmd_Register;
		api_i->Cmd_BufPrintf = Cmd_BufPrintf;
		//api_i->Cmd_ExecBuf = Cmd_ExecBuf;
		api_i->Cmd_Exec = Cmd_Exec;
		api_i->Cmd_FlushScriptBuffer = Cmd_FlushScriptBuffer;
		api_i->Cmd_ReadConfigFileVars = Cmd_ReadConfigFileVars;
		api_i->Cmd_Enable = Cmd_Enable;
		api_i->Cmd_Disable = Cmd_Disable;
		api_i->Cmd_ProcessString = Cmd_ProcessString;
		api_i->Cvar_Register = Cvar_Register;
		api_i->Cvar_Set = Cvar_Set;
		api_i->Cvar_SetVar = Cvar_SetVar;
		api_i->Cvar_SetValue = Cvar_SetValue;
		api_i->Cvar_GetValue = Cvar_GetValue;
		api_i->Cvar_GetString = Cvar_GetString;
		api_i->Cvar_GetInteger = Cvar_GetInteger;
		api_i->Cvar_SetVarValue = Cvar_SetVarValue;
		api_i->Cvar_GetModifiedCount = Cvar_GetModifiedCount;
		api_i->Console_Printf = Console_Printf;
		api_i->Console_DPrintf = Console_DPrintf;
		api_i->Console_Errorf = Console_Errorf;
//		api_i->WR_FitQuad = WR_FitQuad;
		api_i->Input_Event = Input_Event;
		api_i->Input_SetMouseMode = Input_SetMouseMode;
		api_i->Input_GetMouseMode = Input_GetMouseMode;
		api_i->Input_IsKeyDown = Input_IsKeyDown;
		api_i->Input_CenterMouse = Input_CenterMouse;
		api_i->Input_SetMouseAngles = Input_SetMouseAngles;
		api_i->Input_SetMouseXY = Input_SetMouseXY;
		api_i->Input_GetMousePos = Input_GetMousePos;
		api_i->Input_ActivateInputCallback = Input_ActivateInputCallback;
		api_i->Input_DeactivateInputCallback = Input_DeactivateInputCallback;
		api_i->Input_GetButtons = Input_GetButtons;
		api_i->Scene_AddObject = Scene_AddObject;
		api_i->Scene_AddOccluder = Scene_AddOccluder;
		api_i->Scene_AddLight = Scene_AddLight;
		api_i->Scene_Clear = Scene_Clear;
		api_i->Scene_Render = Scene_Render;
		api_i->Scene_AddPoly = Scene_AddPoly;
		api_i->Scene_AddSkyObj = Scene_AddSkyObj;
		api_i->Scene_SelectObjects = Scene_SelectObjects;
		api_i->Draw_SetShaderTime = Draw_SetShaderTime;
		api_i->Draw_SetColor = Draw_SetColor;
		api_i->Draw_Quad2d = Draw_Quad2d;
		api_i->Draw_Poly2d = Draw_Poly2d;
	//	api_i->Draw_RotatedQuad2d = Draw_RotatedQuad2d;
		api_i->Color_Clamp = Color_Clamp;
		api_i->Color_ToFloat = Color_ToFloat;
		api_i->Color_ToByte = Color_ToByte;
		api_i->Vid_GetScreenW = Vid_GetScreenW;
		api_i->Vid_GetScreenH = Vid_GetScreenH;
		api_i->Vid_ProjectVertex = Vid_ProjectVertex;
		api_i->Vid_ReadZBuffer = Vid_ReadZBuffer;
		api_i->Cam_ConstructRay = Cam_ConstructRay;
		api_i->Milliseconds = Host_Milliseconds;		
		api_i->FrameSeconds = Host_FrameSeconds;
		api_i->FrameMilliseconds = Host_FrameMilliseconds;
		api_i->GetLogicFPS = Host_GetLogicFPS;
		api_i->GetSavageLogoShader = Host_GetSavageLogoShader;
		api_i->GetWhiteShader = Host_GetWhiteShader;		
		api_i->GetLoadingScreenShader = Host_GetLoadingScreenShader;
		api_i->GetSysfontShader = Host_GetSysfontShader;
		api_i->GetNicefontShader = Host_GetNicefontShader;
		api_i->Res_LoadModel = Res_LoadModel;
		api_i->Res_GetModelSurfaceBounds = Res_GetModelSurfaceBounds;
		api_i->Res_LoadSound = Res_LoadSound;
		api_i->Res_LoadSkin = Res_LoadSkin;
		api_i->Res_LoadShader = Res_LoadShader;
		api_i->Res_LoadShaderEx = Res_LoadShaderEx;
		api_i->Res_LoadTerrainShader = Res_LoadTerrainShader;
		api_i->Res_GetModelVisualBounds = Res_GetModelVisualBounds;
		api_i->Res_IsShaderFile = Res_IsShaderFile;
		api_i->Res_GetNumTextureFrames = Res_GetNumTextureFrames;
		api_i->Res_GetAnimatedTextureFPS = Res_GetAnimatedTextureFPS;
		api_i->Res_GetDynamapShader = Res_GetDynamapShader;
		api_i->Bitmap_Load = Bitmap_Load;
		api_i->Bitmap_GetColor = Bitmap_GetColor;
		api_i->Bitmap_Free = Bitmap_Free;
		api_i->Bitmap_Scale = Bitmap_Scale;
		api_i->Bitmap_GenerateThumbnails = Bitmap_GenerateThumbnails;
		api_i->Bitmap_SetPixel4b = Bitmap_SetPixel4b;
		api_i->Sound_Play = Sound_Play;
		api_i->Sound_ClearLoopingSounds = Sound_ClearLoopingSounds;
		api_i->Sound_AddLoopingSound = Sound_AddLoopingSound;
		api_i->Sound_StopSource = Sound_StopSource;
		api_i->Sound_StopHandle = Sound_StopHandle;
		api_i->Sound_StopChannel = Sound_StopChannel;
		api_i->Sound_MoveSource = Sound_MoveSource;
		api_i->Sound_SetListenerPosition = Sound_SetListenerPosition;
		api_i->Sound_PlayMusic = Sound_PlayMusic;
		api_i->Sound_StopMusic = Sound_StopMusic;
		api_i->GUI_GetUserdata = GUI_GetUserdata;
		api_i->GUI_SetUserdata = GUI_SetUserdata;
		api_i->GUI_RegisterClass = GUI_RegisterClass;
		api_i->GUI_SetName = GUI_SetName;
		api_i->GUI_SetClass = GUI_SetClass;
		api_i->GUI_Notify = GUI_Notify;
		api_i->GUI_IsVisible = GUI_IsVisible;
		api_i->GUI_IsInteractive = GUI_IsInteractive;
		api_i->GUI_Exec = GUI_Exec;
		api_i->GUI_Move = GUI_Move;
		api_i->GUI_Resize = GUI_Resize;
		api_i->GUI_Show = GUI_Show;
		api_i->GUI_Hide = GUI_Hide;
		api_i->GUI_Unfocus = GUI_Unfocus;
		api_i->GUI_Focus = GUI_Focus;
		api_i->GUI_Select = GUI_Select;
		api_i->GUI_Param = GUI_Param;
		api_i->GUI_UpdateDims = GUI_UpdateDims;
		api_i->GUI_GetPosition = GUI_GetPosition;
		api_i->GUI_GetSize = GUI_GetSize;
		api_i->GUI_FadeOut = GUI_FadeOutObject;
		api_i->GUI_FadeIn = GUI_FadeOutObject;
		api_i->GUI_GetWidgetAtXY = GUI_GetWidgetAtXY;
		api_i->GUI_CheckMouseAgainstUI = GUI_CheckMouseAgainstUI;
		api_i->GUI_SendMouseDown = GUI_SendMouseDown;
		api_i->GUI_SendMouseUp = GUI_SendMouseUp;
		api_i->GUI_WidgetWantsMouseClicks = GUI_WidgetWantsMouseClicks;
		api_i->GUI_WidgetWantsKey = GUI_WidgetWantsKey;
		api_i->GUI_ResetFocus = GUI_ResetFocus;
		api_i->GUI_ActivateNextInteractiveWidget = GUI_ActivateNextInteractiveWidget;
		api_i->GUI_RotatedQuad2d_S = GUI_RotatedQuad2d_S;
		api_i->GUI_Quad2d_S = GUI_Quad2d_S;
		api_i->GUI_ShadowQuad2d_S = GUI_ShadowQuad2d_S;
		api_i->GUI_GetStringRowsCols = GUI_GetStringRowsCols;
		api_i->GUI_DrawString = GUI_DrawString;
		api_i->GUI_DrawShadowedString = GUI_DrawShadowedString;
		api_i->GUI_DrawString_S = GUI_DrawString_S;
		api_i->GUI_DrawStringBillboard = GUI_DrawStringBillboard;
		api_i->GUI_DrawStringMonospaced = GUI_DrawStringMonospaced;
		api_i->GUI_StringWidth = GUI_StringWidth_S;
		api_i->GUI_LineBox2d_S = GUI_LineBox2d_S;
		api_i->GUI_SetRGB = GUI_SetRGB;
		api_i->GUI_SetRGBA = GUI_SetRGBA;
		api_i->GUI_Panel_AddObject = GUI_Panel_AddObject;
		api_i->GUI_Panel_Move = GUI_Panel_Move;
		api_i->GUI_Panel_MoveRelative = GUI_Panel_MoveRelative;
		api_i->GUI_Panel_Hide = GUI_Panel_Hide;
		api_i->GUI_Panel_Show = GUI_Panel_Show;
		api_i->GUI_GetPanel = GUI_GetPanel;
		api_i->GUI_AddElement = GUI_AddElement;
		api_i->GUI_GetScreenPosition = GUI_GetScreenPosition;
		api_i->GUI_GetScreenSize = GUI_GetScreenSize;
		api_i->GUI_GetObject = GUI_GetObject;
		api_i->GUI_GetClass = GUI_GetClass;
		api_i->GUI_List_Cmd = GUI_List_Cmd;
		api_i->GUI_Draw = GUI_Draw;
		api_i->GUI_Init = GUI_Init;
		api_i->GUI_Malloc = GUI_Malloc;
		api_i->GUI_Free = GUI_Free;
		api_i->GUI_ReAlloc = GUI_ReAlloc;
		api_i->GUI_StrDup = GUI_StrDup;
		api_i->GUI_Coord = GUI_Coord;
		api_i->GUI_ConvertToScreenCoord = GUI_ConvertToScreenCoord;
		api_i->GUI_ScaleToScreen = GUI_ScaleToScreen;
		api_i->GUI_Scale = GUI_Scale;
		api_i->GUI_GetScreenWidth = GUI_GetScreenWidth;
		api_i->GUI_GetScreenHeight = GUI_GetScreenHeight;
		api_i->GUI_HideAllPanels = GUI_HideAllPanels;
		api_i->GUI_DestroyAll = GUI_RemovePanels;

		api_i->IRC_GetBuddyList = IRC_GetBuddyList;
		api_i->IRC_GetUserList = IRC_GetUserList;
		api_i->IRC_OutputCallback = IRC_OutputCallback;
		api_i->IRC_OutputMsgCallback = IRC_OutputMsgCallback;
		
		api_i->MasterServer_GetGameList = MasterServer_GetGameList;
		api_i->MasterServer_GetGameList_Frame = MasterServer_GetGameList_Frame;
		api_i->MasterServer_GetGameInfo = MasterServer_GetGameInfo;
		api_i->MasterServer_FindUsers = MasterServer_FindUsers;
		api_i->MasterServer_GetUserList_Frame = MasterServer_GetUserList_Frame;
		api_i->MasterServer_GetUserInfo = MasterServer_GetUserInfo;
		api_i->MasterServer_GetUserInfo_Frame = MasterServer_GetUserInfo_Frame;

		api_i->Client_GetConnectionState = Client_GetConnectionState;

		api_i->World_GetName = World_GetName;
	}

	if (api_shared)
	{
		api_shared->System_Dir = System_Dir;
		api_shared->Cmd_Register = Cmd_Register;
		api_shared->Cmd_BufPrintf = Cmd_BufPrintf;
		//api_shared->Cmd_ExecBuf = Cmd_ExecBuf;
		api_shared->Cmd_Exec = Cmd_Exec;
		api_shared->Cmd_FlushScriptBuffer = Cmd_FlushScriptBuffer;
		api_shared->Cmd_ReadConfigFileVars = Cmd_ReadConfigFileVars;
		api_shared->Cmd_Enable = Cmd_Enable;
		api_shared->Cmd_Disable = Cmd_Disable;
		api_shared->Cvar_AllowCheats = Cvar_AllowCheats;
		api_shared->Cvar_BlockCheats = Cvar_BlockCheats;
		api_shared->Cvar_Register = Cvar_Register;
		api_shared->Cvar_Set = Cvar_Set;
		api_shared->Cvar_SetVar = Cvar_SetVar;
		api_shared->Cvar_SetValue = Cvar_SetValue;
		api_shared->Cvar_GetValue = Cvar_GetValue;
		api_shared->Cvar_GetInteger = Cvar_GetInteger;
		api_shared->Cvar_GetString = Cvar_GetString;
		api_shared->Cvar_SetVarValue = Cvar_SetVarValue;
		api_shared->Cvar_GetModifiedCount = Cvar_GetModifiedCount;
		api_shared->Console_Printf = Console_Printf;
		api_shared->Console_DPrintf = Console_DPrintf;
		api_shared->Console_Errorf = Console_Errorf;
		api_shared->Milliseconds = Host_Milliseconds;		
		api_shared->System_GetPerfCounter = System_GetPerfCounter;
		api_shared->GetLogicFPS = Host_GetLogicFPS;
		api_shared->GetSavageLogoShader = Host_GetSavageLogoShader;
		api_shared->GetWhiteShader = Host_GetWhiteShader;
		api_shared->GetSysfontShader = Host_GetSysfontShader;
		api_shared->File_Open = File_Open;
#ifdef unix
		api_shared->File_OpenAbsolute = File_OpenAbsolute;
#endif
		api_shared->File_Close = File_Close;
		api_shared->File_Exists = File_Exists;
		api_shared->File_Printf = File_Printf;
		api_shared->File_Read = File_Read;
		api_shared->File_Write = File_Write;
		api_shared->File_GetNextFileIncrement = File_GetNextFileIncrement;
		api_shared->File_GetCurrentDir = File_GetCurrentDir;
		api_shared->IRC_OutputCallback = IRC_OutputCallback;
		api_shared->IRC_OutputMsgCallback = IRC_OutputMsgCallback;
		api_shared->IRC_GetUserList = IRC_GetUserList;
		api_shared->IRC_GetBuddyList = IRC_GetBuddyList;
		api_shared->Game_Error = Game_Error;
		api_shared->Res_LoadStringTable = Res_LoadStringTable;
		api_shared->Str_Get = Str_Get;

		api_shared->Allocator_Allocate = Allocator_Allocate;
		api_shared->Allocator_Deallocate = Allocator_Deallocate;

		api_shared->Tag_Malloc = Tag_MallocSharedGame;
		api_shared->Tag_Free = Tag_Free;		
	}

	if (api_s)
	{
		api_s->System_Dir = System_Dir;
		api_s->CopyVec2 = M_CopyVec2;
		api_s->CopyVec3 = M_CopyVec3;
		api_s->CopyVec4 = M_CopyVec4;
		api_s->Cmd_Register = Cmd_Register;
		api_s->Cmd_BufPrintf = Cmd_BufPrintf;
		//api_s->Cmd_ExecBuf = Cmd_ExecBuf;
		api_s->Cmd_Exec = Cmd_Exec;
		api_s->Cmd_FlushScriptBuffer = Cmd_FlushScriptBuffer;
		api_s->Cmd_ReadConfigFileVars = Cmd_ReadConfigFileVars;
		api_s->Cmd_Enable = Cmd_Enable;
		api_s->Cmd_Disable = Cmd_Disable;
		api_s->Cvar_Register = Cvar_Register;
		api_s->Cvar_Set = Cvar_Set;
		api_s->Cvar_SetVar = Cvar_SetVar;
		api_s->Cvar_SetValue = Cvar_SetValue;
		api_s->Cvar_GetValue = Cvar_GetValue;
		api_s->Cvar_GetInteger = Cvar_GetInteger;
		api_s->Cvar_GetString = Cvar_GetString;
		api_s->Cvar_SetVarValue = Cvar_SetVarValue;
		api_s->Cvar_GetModifiedCount = Cvar_GetModifiedCount;
		api_s->Console_Printf = Console_Printf;
		api_s->Console_DPrintf = Console_DPrintf;
		api_s->Console_Errorf = Console_Errorf;
		api_s->World_SampleGround = World_SampleGround;
		api_s->World_GetBounds = World_GetBounds;
		api_s->World_GetGridHeight = World_GetGridHeight;
		api_s->World_Destroy = World_Destroy;
		api_s->World_DeformGround = World_DeformGround;
//		api_s->World_PlaceSolid = WT_PlaceSolid;
//		api_s->World_RemoveSolid = WT_RemoveSolid;
//		api_s->World_TestBox = WT_TestBox;
//		api_s->World_TraceLineSegment = WT_TraceLineSegment;
//		api_s->World_TestSolid = WT_TestSolid;
		api_s->World_TraceBox = WT_TraceBox_Server;				//server-side version
		api_s->World_TraceBoxEx = WT_TraceBoxEx_Server;				//server-side version
		api_s->World_LinkObject = WT_LinkObject_Server;			//server-side version
		api_s->World_UnlinkObject = WT_UnlinkObject_Server;		//server-side version
		api_s->World_IsLinked = WT_IsLinked_Server;
		api_s->World_GetName = World_GetName;
		api_s->World_CalcMaxZ = World_CalcMaxZUnaligned;
		api_s->WorldToGrid = World_WorldToGrid;
		api_s->GridToWorld = World_GridToWorld;
		api_s->WO_GetNumObjdefs = WO_GetNumObjdefs;
		api_s->WO_GetObjdefName = WO_GetObjdefName;
		api_s->WO_RegisterObjectVar = WO_RegisterObjectVar;
		api_s->WO_GetObjdefVar = WO_GetObjdefVar;
		api_s->WO_GetObjdefVarValue = WO_GetObjdefVarValue;
		api_s->WO_UseObjdef = WO_UseObjdef;
		api_s->WO_GetObjectPos = WO_GetObjectPos;
		api_s->WO_CreateObjectClass = WO_CreateObjectClass;
		api_s->WO_CreateObject = WO_CreateObject_Server;
		api_s->WO_ClearObjects = WO_ClearObjects;
		api_s->WO_GetObjectBounds = WO_GetObjectBounds;
		api_s->WO_DeleteObject = WO_DeleteObject_Server;
		api_s->WO_GetObjectObjdef = WO_GetObjectObjdef;
		api_s->WO_GetObjectModel = WO_GetObjectModel;
		api_s->WO_GetObjectSkin = WO_GetObjectSkin;
		api_s->WO_GetObjdefId = WO_GetObjdefId;
		api_s->WO_IsObjectDoubleSided = WO_IsObjectDoubleSided;
		api_s->WO_FindReferenceObject = WO_FindReferenceObject;
		api_s->WOG_FindClosestObjects = WOG_FindClosestObjects_Server;
		api_s->WOG_FindObjectsInRadius = WOG_FindObjectsInRadius_Server;
		api_s->NavRep_PathCreateToPosition = NavRep_PathCreateToPosition;
		api_s->NavRep_PathCreateToObject = NavRep_PathCreateToObject;
		api_s->NavRep_PathDestroy = NavRep_PathDestroy;
		api_s->NavRep_PathOptimize = NavRep_PathOptimize;
		api_s->NavRep_Trace = NavRep_Trace;
		api_s->NavRep_CanPlaceBuilding = NavRep_CanPlaceBuilding;
		api_s->NavRep_CSGSubtract = NavRep_CSGSubtract;
		api_s->NavRep_CSGAdd = NavRep_CSGAdd;
//		api_s->Path_FindPath = Path_FindPath;
//		api_s->DPath_FindPath = DPath_FindPath;
//		api_s->Path_FreePath = Path_FreePath;
		api_s->Res_LoadModel = Res_LoadModel;
		api_s->Res_GetModelSurfaceBounds = Res_GetModelSurfaceBounds;
		api_s->Cam_ConstructRay = Cam_ConstructRay;
		api_s->System_Milliseconds = System_Milliseconds;
		api_s->Milliseconds = Host_Milliseconds;		
		api_s->GetLogicFPS = Host_GetLogicFPS;
		api_s->Pkt_Clear = Pkt_Clear;
		api_s->Pkt_WriteInt = Pkt_WriteInt;
		api_s->Pkt_WriteShort = Pkt_WriteShort;
		api_s->Pkt_WriteByte = Pkt_WriteByte;
		api_s->Pkt_WriteString = Pkt_WriteString;
		api_s->Pkt_WriteCmd = Pkt_WriteCmd;
		api_s->Pkt_WriteCoord = Pkt_WriteCoord;
		api_s->Pkt_WriteByteAngle = Pkt_WriteByteAngle;
		api_s->Pkt_WriteWordAngle = Pkt_WriteWordAngle;
		api_s->Pkt_WriteFloat = Pkt_WriteFloat;
		api_s->Server_GetNumClients = Server_GetNumClients;
		api_s->Server_BroadcastMessage = Server_BroadcastMessage;
		api_s->Server_SendMessage = Server_SendMessage;
		api_s->Server_SendUnreliableMessage = Server_SendUnreliableMessage;
		api_s->Server_SpawnObject = Server_SpawnObject;
		api_s->Server_GameObjectPointer = Server_GameObjectPointer;
		api_s->Server_ClientExclusionListPointer = Server_ClientExclusionListPointer;
		api_s->Server_UpdatePlayerState = Server_UpdatePlayerState;
		api_s->Server_FreeObject = Server_FreeObject;
		api_s->Server_GetClientCookie = Server_GetClientCookie;
		api_s->Server_GetClientUID = Server_GetClientUID;
		api_s->Server_GetClientGUID = Server_GetClientGUID;
		api_s->Server_CheckForVIP = Server_CheckForVIP;
		api_s->Server_GetPort = Server_GetPort;
		api_s->Server_GetStatus = Server_GetStatus;
		api_s->Server_GetStateString = Server_GetStateString;
		api_s->Server_SetStateString = Server_SetStateString;
		api_s->Server_SetRequestOnly = Server_SetRequestOnly;
		api_s->Server_SendRequestString = Server_SendRequestString;
		api_s->Server_StartStats = Server_StartStats;
		api_s->Server_AddClientStats = Server_AddClientStats;
		api_s->Server_SendStats = Server_SendStats;
		api_s->Server_GetClientPing = Server_GetClientPing;
		api_s->Server_GetClientIP = Server_GetClientIP;
		api_s->Server_AllocVirtualClientSlot = Server_AllocVirtualClientSlot;
#ifdef SAVAGE_DEMO
		api_s->Server_IsDemoPlayer = Server_IsDemoPlayer;
#endif

		api_s->Tag_Malloc	= Tag_MallocServerGame;
		api_s->Tag_Free		= Tag_Free;
		api_s->Tag_MallocGameScript	= Tag_MallocGameScript;
		api_s->Tag_FreeGameScript	= Tag_FreeGameScript;
	}
}

